library(kmed)
library(ggplot2)
source("00function.R")
set.seed(2019)
data("clust5")
dist5 <- as.matrix(dist(clust5[,1:2]))

## SFKM algorithm
sfkm <- fastkmed(dist5, 5)

## SKM algorithm
skm <- skmedoidR(dist5, 5)

df <- data.frame(x = clust5$x1, y = clust5$x2, sfkm = sfkm$cluster, skm = skm$cluster)
#Figure 1
p <- ggplot(df, aes(x, y, shape = factor(sfkm))) +
  geom_point(size = 6) + geom_point(colour = "grey90", size = 1.5) +
  scale_shape(guide = "none") + 
  theme(axis.title = element_text(size=30), 
        plot.title = element_text(size = 30),
        axis.text = element_text(size = 10)) +
  labs(title = "a") + coord_fixed(ratio = 0.8)
#Figure 2
q <- ggplot(df, aes(x, y, shape = factor(skm))) +
  geom_point(size = 6) + geom_point(colour = "grey90", size = 1.5) +
  scale_shape(guide = "none") + 
  theme(axis.title = element_text(size=30), 
        plot.title = element_text(size = 30),
        axis.text = element_text(size = 10)) +
  labs(title = "b") + coord_fixed(ratio = 0.8)

gridExtra::grid.arrange(p, q, ncol = 2)

