###########iris data
library(kmed)
source("00function.R")
set.seed(2019)
data(iris)
irisgendist <- numdata(iris[,-5], nclust = 3, idclass = iris[,5])
iriscan <- as.matrix(dist(iris[,-5], method = "canberra"))
iriscanrest <- maxdiagonal(cbind(skmedoidR(iriscan, nclust = 3)$cluster, iris[,5]))
iriscanberra <- sum(diag(table(iriscanrest[,1], iriscanrest[,2])))/nrow(iris)
names(iriscanberra) <- "Canberra"
table8 <- c(irisgendist, iriscanberra)
#####Table 8
round(table8, 3)

#############wine
wine <- read.table("path/wine.txt",sep=",")
winegendist <- numdata(wine[,-1], nclust = 3, idclass = wine[,1])
winecan <- as.matrix(dist(wine[,-1], method = "canberra"))
winecanrest <-  maxdiagonal(cbind(skmedoidR(winecan, nclust = 3)$cluster, wine[,1]))
winecanberra <- sum(diag(table(iriscanrest[,1], iriscanrest[,2])))/nrow(wine)
names(winecanberra) <- "Canberra"
table9 <- c(winegendist, winecanberra)
#####Table 9
round(table9, 3)

#############soybean data
soybean <- read.table("path/soy.txt",sep=",")
soybeangendist <- catdata(soybean[,-36], nclust = 4, idclass = as.numeric(soybean[,36]))
##Table 10
round(soybeangendist, 3)

###############vote data
vote <- read.table("path/vote.txt",sep=",")
votengendist <- catdata(vote[,-1], nclust = 2, idclass = as.numeric(vote[,1]))
##Table 11
round(votengendist, 3)

#zoo data
zoo <- read.table("path/zoo.txt", header = TRUE, row.names = 1)
gowerzoo <- distmix(zoo, method = "gower", idnum = 13, idcat = c(1:12,14:16))
wishartzoo <- distmix(zoo, method = "wishart", idnum = 13, idcat = c(1:12,14:16))
podanizoo <- distmix(zoo, method = "podani", idnum = 13, idcat = c(1:12,14:16))
huangzoo <- distmix(zoo, method = "huang", idnum = 13, idcat = c(1:12,14:16))
harizoo <- distmix(zoo, method = "harikumar", idnum = 13, idcat = c(1:12,14:16))
esimmazoo <- as.matrix(dist(zoo[,13, drop = FALSE])) + 
  matching(zoo[,c(1:12,14:16), drop = FALSE],zoo[,c(1:12,14:16), drop = FALSE])
marwecozoo <- distNumeric(as.matrix(zoo[,13]), as.matrix(zoo[,13])) +
  cooccur(zoo[,c(1:12,14:16), drop= FALSE])
alldistzoo <- list(gowerzoo, wishartzoo, podanizoo, huangzoo, harizoo, esimmazoo,
                   marwecozoo)
resultzoo <- vector("list", 7)
for (i in 1:7) {
  skm <- skmedoidR(alldistzoo[[i]], 7, seeding = 20)$cluster
  classmember <- cbind(skm, zoo[,17])
  maxmembership <- maxdiagonal(classmember)
  resultzoo[[i]] <- table(maxmembership[,1], maxmembership[,2])
}
accuracyzoo <- sapply(resultzoo, function(x) sum(diag(x))/sum(x))
names(accuracyzoo) <- c("Gower", "Wishart", "Podani", "Huang", "Harikumar", "Esimma", "Marweco")

#Table 12
round(accuracyzoo, 3)

############credit apporval
credit <- read.table("path/credit.txt", sep = ",")
credit <- na.omit(credit)
gowercredit <- distmix(credit, method = "gower", idnum = c(2:3,8,11,14:15), 
                       idcat = c(1,4:7,9:10,12:13))
wishartcredit <- distmix(credit, method = "wishart", idnum = c(2:3,8,11,14:15), 
                         idcat = c(1,4:7,9:10,12:13))
podanicredit <- distmix(credit, method = "podani", idnum = c(2:3,8,11,14:15), 
                        idcat = c(1,4:7,9:10,12:13))
huangcredit <- distmix(credit, method = "huang", idnum = c(2:3,8,11,14:15), 
                       idcat = c(1,4:7,9:10,12:13))
haricredit <- distmix(credit, method = "harikumar", idnum = c(2:3,8,11,14:15), 
                      idcat = c(1,4:7,9:10,12:13))
esimmacredit <- as.matrix(dist(credit[,c(2:3,8,11,14:15), drop = FALSE])) + 
  matching(credit[,c(1,4:7,9:10,12:13), drop = FALSE],credit[,c(1,4:7,9:10,12:13), drop = FALSE])
marwecocredit <- distNumeric(as.matrix(credit[,c(2:3,8,11,14:15)]), 
                             as.matrix(credit[,c(2:3,8,11,14:15)])) +
  cooccur(credit[,c(1,4:7,9:10,12:13), drop= FALSE])
alldistcredit <- list(gowercredit, wishartcredit, podanicredit, huangcredit, haricredit, 
                   esimmacredit, marwecocredit)
resultcredit <- vector("list", 7)
for (i in 1:7) {
  skm <- skmedoidR(alldistcredit[[i]], 2, seeding = 20)$cluster
  classmember <- cbind(skm, as.numeric(credit[,16]))
  maxmembership <- maxdiagonal(classmember)
  resultcredit[[i]] <- table(maxmembership[,1], maxmembership[,2])
}
accuracycredit <- sapply(resultcredit, function(x) sum(diag(x))/sum(x))
names(accuracycredit) <- c("Gower", "Wishart", "Podani", "Huang", "Harikumar", "Esimma", "Marweco")

#Table 13
round(accuracycredit, 3)
